/*     BIBLIOTHEQUE 

Le module gre les fonctions associes  la recherche des livres
	. saisie des critres
	. validation des critres
	
Les critres sont enregistrs dans des cookies.

DJ 13.12.2014
*/



// Modules
var omep=require('X:/.../controleurs/presentation');
var odb=require("X:/.../basedonnees");
var ogen=require('X:/.../controleurs/general');

// exportation des fonctions
exports.saisie = saisie;
exports.saisievalid = saisievalid;
exports.saisieraz = saisieraz;


// domaine concern pour personnaliser notamment les scripts intgrs dans la page finale
var domaine = "recherche";



/*-------------------------------------------------------------------------------------------------
SAISIE DES CRITERES - AFFICHAGE FORMULAIRE
-------------------------------------------------------------------------------------------------*/

function saisie(request, response) {
	console.log("Execution de la saisie des critres de recherche.");

	var zechange=ogen.init_zechange("RECHERCHE DE LIVRES", domaine);
	// affichr  partir des cookies
	zechange.ligne.id=0;
	zechange.ligne.auteur_id = request.cookies.cklivaut;
	zechange.ligne.cklivcat = request.cookies.cklivcat;
	zechange.ligne.cklivtit = request.cookies.cklivtit;

	// afficher le formulaire avec l'objet cr
	charger_donnees_afficher (request, response, zechange);

}



/*-------------------------------------------------------------------------------------------------
VALIDATION DE LA SAISIE DES CRITERES
-------------------------------------------------------------------------------------------------*/

function saisievalid(request, response) {

	console.log("validation de la saisie des critres");

	//-----  Lecture du formulaire

	if (request.method != 'POST') {
		return;
	}

	// mettre  jour les cookies
	response.cookie('cklivtit', request.body.zlivtit);
	response.cookie('cklivaut', request.body.zlivaut);
	response.cookie('cklivcat', request.body.zlivcat);

	// lancer la liste des livres
	response.writeHead(302, {'Location': c_livres_url_liste });
	response.end();			

}



/*-------------------------------------------------------------------------------------------------
RAZ DES CRITERES
-------------------------------------------------------------------------------------------------*/

function saisieraz (request, response, zechange) {
	console.log("validation de l'effacement de la saise des critres de recherche");

	//-----  Maj des critres
	response.cookie("cklivaut", "");
	response.cookie('cklivtit', "");
	response.cookie('cklivcat', "");

	//-----  On raffiche la saisie des critres, vides cette fois
	response.writeHead(302, {'Location': c_livres_url_recherche });
	response.end();			

}



/*-------------------------------------------------------------------------------------------------
CHARGEMENT DES DONNEES
	. charger la liste des auteurs, puis celle des categories. 
	. afficher ensuite la page
-------------------------------------------------------------------------------------------------*/

function charger_donnees_afficher (request, response, zechange) {
	odb.charger_liste_auteurs(  request, response, zechange, function() {
		odb.charger_liste_categories(  request, response, zechange, function() {
			omep.afficher_page(request, response, c_livres_vue_recherche, zechange);
		});
	});

}

